/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2013 Digia Plc and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <destroylistener.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptionfocusrect_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionFocusRect_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QStyleOptionFocusRect >()))
        return -1;

    ::QStyleOptionFocusRect* cptr = 0;
    int overloadId = -1;
    PythonToCppFunc pythonToCpp[] = { 0 };
    SBK_UNUSED(pythonToCpp)
    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionFocusRect", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QStyleOptionFocusRect()
    // 1: QStyleOptionFocusRect(QStyleOptionFocusRect)
    // 2: QStyleOptionFocusRect(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionFocusRect()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppConvertible(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))) {
        overloadId = 2; // QStyleOptionFocusRect(int)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::isPythonToCppReferenceConvertible((SbkObjectType*)SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_IDX], (pyArgs[0])))) {
        overloadId = 1; // QStyleOptionFocusRect(QStyleOptionFocusRect)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionFocusRect_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QStyleOptionFocusRect()
        {

            if (!PyErr_Occurred()) {
                // QStyleOptionFocusRect()
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QStyleOptionFocusRect();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
        case 1: // QStyleOptionFocusRect(const QStyleOptionFocusRect & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QStyleOptionFocusRect* cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!PyErr_Occurred()) {
                // QStyleOptionFocusRect(QStyleOptionFocusRect)
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QStyleOptionFocusRect(*cppArg0);
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
        case 2: // QStyleOptionFocusRect(int version)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);

            if (!PyErr_Occurred()) {
                // QStyleOptionFocusRect(int)
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new ::QStyleOptionFocusRect(cppArg0);
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QStyleOptionFocusRect >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionFocusRect_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionFocusRect_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionFocusRect", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionFocusRect", overloads);
        return -1;
}

static PyMethodDef Sbk_QStyleOptionFocusRect_methods[] = {

    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionFocusRect_get_backgroundColor(PyObject* self, void*)
{
    ::QStyleOptionFocusRect* cppSelf = 0;
    SBK_UNUSED(cppSelf)
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = ((::QStyleOptionFocusRect*)Shiboken::Conversions::cppPointer(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_IDX], (SbkObject*)self));
    PyObject* pyOut = Shiboken::Object::newObject((SbkObjectType*)SbkPySide_QtGuiTypes[SBK_QCOLOR_IDX], &(cppSelf->backgroundColor), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QStyleOptionFocusRect_set_backgroundColor(PyObject* self, PyObject* pyIn, void*)
{
    ::QStyleOptionFocusRect* cppSelf = 0;
    SBK_UNUSED(cppSelf)
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = ((::QStyleOptionFocusRect*)Shiboken::Conversions::cppPointer(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_IDX], (SbkObject*)self));
    if (pyIn == 0) {
        PyErr_SetString(PyExc_TypeError, "'backgroundColor' may not be deleted");
        return -1;
    }
    PythonToCppFunc pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::isPythonToCppValueConvertible((SbkObjectType*)SbkPySide_QtGuiTypes[SBK_QCOLOR_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'backgroundColor', 'QColor' or convertible type expected");
        return -1;
    }

    ::QColor& cppOut_ptr = cppSelf->backgroundColor;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for QStyleOptionFocusRect
static PyGetSetDef Sbk_QStyleOptionFocusRect_getsetlist[] = {
    {const_cast<char*>("backgroundColor"), Sbk_QStyleOptionFocusRect_get_backgroundColor, Sbk_QStyleOptionFocusRect_set_backgroundColor},
    {0}  // Sentinel
};

} // extern "C"

static int Sbk_QStyleOptionFocusRect_traverse(PyObject* self, visitproc visit, void* arg)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_traverse(self, visit, arg);
}
static int Sbk_QStyleOptionFocusRect_clear(PyObject* self)
{
    return reinterpret_cast<PyTypeObject*>(&SbkObject_Type)->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionFocusRect_Type = { { {
    PyVarObject_HEAD_INIT(&SbkObjectType_Type, 0)
    /*tp_name*/             "PySide.QtGui.QStyleOptionFocusRect",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_HAVE_GC,
    /*tp_doc*/              0,
    /*tp_traverse*/         Sbk_QStyleOptionFocusRect_traverse,
    /*tp_clear*/            Sbk_QStyleOptionFocusRect_clear,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionFocusRect_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionFocusRect_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionFocusRect_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


// Type conversion functions.

// Python to C++ enum conversion.
static void QStyleOptionFocusRect_StyleOptionType_PythonToCpp_QStyleOptionFocusRect_StyleOptionType(PyObject* pyIn, void* cppOut) {
    *((::QStyleOptionFocusRect::StyleOptionType*)cppOut) = (::QStyleOptionFocusRect::StyleOptionType) Shiboken::Enum::getValue(pyIn);

}
static PythonToCppFunc is_QStyleOptionFocusRect_StyleOptionType_PythonToCpp_QStyleOptionFocusRect_StyleOptionType_Convertible(PyObject* pyIn) {
    if (PyObject_TypeCheck(pyIn, SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX]))
        return QStyleOptionFocusRect_StyleOptionType_PythonToCpp_QStyleOptionFocusRect_StyleOptionType;
    return 0;
}
static PyObject* QStyleOptionFocusRect_StyleOptionType_CppToPython_QStyleOptionFocusRect_StyleOptionType(const void* cppIn) {
    int castCppIn = *((::QStyleOptionFocusRect::StyleOptionType*)cppIn);
    return Shiboken::Enum::newItem(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX], castCppIn);

}

static void QStyleOptionFocusRect_StyleOptionVersion_PythonToCpp_QStyleOptionFocusRect_StyleOptionVersion(PyObject* pyIn, void* cppOut) {
    *((::QStyleOptionFocusRect::StyleOptionVersion*)cppOut) = (::QStyleOptionFocusRect::StyleOptionVersion) Shiboken::Enum::getValue(pyIn);

}
static PythonToCppFunc is_QStyleOptionFocusRect_StyleOptionVersion_PythonToCpp_QStyleOptionFocusRect_StyleOptionVersion_Convertible(PyObject* pyIn) {
    if (PyObject_TypeCheck(pyIn, SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX]))
        return QStyleOptionFocusRect_StyleOptionVersion_PythonToCpp_QStyleOptionFocusRect_StyleOptionVersion;
    return 0;
}
static PyObject* QStyleOptionFocusRect_StyleOptionVersion_CppToPython_QStyleOptionFocusRect_StyleOptionVersion(const void* cppIn) {
    int castCppIn = *((::QStyleOptionFocusRect::StyleOptionVersion*)cppIn);
    return Shiboken::Enum::newItem(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QStyleOptionFocusRect_PythonToCpp_QStyleOptionFocusRect_PTR(PyObject* pyIn, void* cppOut) {
    Shiboken::Conversions::pythonToCppPointer(&Sbk_QStyleOptionFocusRect_Type, pyIn, cppOut);
}
static PythonToCppFunc is_QStyleOptionFocusRect_PythonToCpp_QStyleOptionFocusRect_PTR_Convertible(PyObject* pyIn) {
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, (PyTypeObject*)&Sbk_QStyleOptionFocusRect_Type))
        return QStyleOptionFocusRect_PythonToCpp_QStyleOptionFocusRect_PTR;
    return 0;
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject* QStyleOptionFocusRect_PTR_CppToPython_QStyleOptionFocusRect(const void* cppIn) {
    PyObject* pyOut = (PyObject*)Shiboken::BindingManager::instance().retrieveWrapper(cppIn);
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    const char* typeName = typeid(*((::QStyleOptionFocusRect*)cppIn)).name();
    return Shiboken::Object::newObject(&Sbk_QStyleOptionFocusRect_Type, const_cast<void*>(cppIn), false, false, typeName);
}

void init_QStyleOptionFocusRect(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionFocusRect_Type);

    if (!Shiboken::ObjectType::introduceWrapperType(module, "QStyleOptionFocusRect", "QStyleOptionFocusRect*",
        &Sbk_QStyleOptionFocusRect_Type, &Shiboken::callCppDestructor< ::QStyleOptionFocusRect >, (SbkObjectType*)SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX])) {
        return;
    }

    // Register Converter
    SbkConverter* converter = Shiboken::Conversions::createConverter(&Sbk_QStyleOptionFocusRect_Type,
        QStyleOptionFocusRect_PythonToCpp_QStyleOptionFocusRect_PTR,
        is_QStyleOptionFocusRect_PythonToCpp_QStyleOptionFocusRect_PTR_Convertible,
        QStyleOptionFocusRect_PTR_CppToPython_QStyleOptionFocusRect);

    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFocusRect");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFocusRect*");
    Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFocusRect&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QStyleOptionFocusRect).name());


    // Initialization of enums.

    // Initialization of enum 'StyleOptionType'.
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QStyleOptionFocusRect_Type,
        "StyleOptionType",
        "PySide.QtGui.QStyleOptionFocusRect.StyleOptionType",
        "QStyleOptionFocusRect::StyleOptionType");
    if (!SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX],
        &Sbk_QStyleOptionFocusRect_Type, "Type", (long) QStyleOptionFocusRect::Type))
        return ;
    // Register converter for enum 'QStyleOptionFocusRect::StyleOptionType'.
    {
        SbkConverter* converter = Shiboken::Conversions::createConverter(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX],
            QStyleOptionFocusRect_StyleOptionType_CppToPython_QStyleOptionFocusRect_StyleOptionType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionFocusRect_StyleOptionType_PythonToCpp_QStyleOptionFocusRect_StyleOptionType,
            is_QStyleOptionFocusRect_StyleOptionType_PythonToCpp_QStyleOptionFocusRect_StyleOptionType_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX], converter);
        Shiboken::Enum::setTypeConverter(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX], converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFocusRect::StyleOptionType");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionType");
    }
    // End of 'StyleOptionType' enum.

    // Initialization of enum 'StyleOptionVersion'.
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX] = Shiboken::Enum::createScopedEnum(&Sbk_QStyleOptionFocusRect_Type,
        "StyleOptionVersion",
        "PySide.QtGui.QStyleOptionFocusRect.StyleOptionVersion",
        "QStyleOptionFocusRect::StyleOptionVersion");
    if (!SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX])
        return ;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX],
        &Sbk_QStyleOptionFocusRect_Type, "Version", (long) QStyleOptionFocusRect::Version))
        return ;
    // Register converter for enum 'QStyleOptionFocusRect::StyleOptionVersion'.
    {
        SbkConverter* converter = Shiboken::Conversions::createConverter(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX],
            QStyleOptionFocusRect_StyleOptionVersion_CppToPython_QStyleOptionFocusRect_StyleOptionVersion);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QStyleOptionFocusRect_StyleOptionVersion_PythonToCpp_QStyleOptionFocusRect_StyleOptionVersion,
            is_QStyleOptionFocusRect_StyleOptionVersion_PythonToCpp_QStyleOptionFocusRect_StyleOptionVersion_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX], converter);
        Shiboken::Enum::setTypeConverter(SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX], converter);
        Shiboken::Conversions::registerConverterName(converter, "QStyleOptionFocusRect::StyleOptionVersion");
        Shiboken::Conversions::registerConverterName(converter, "StyleOptionVersion");
    }
    // End of 'StyleOptionVersion' enum.


    qRegisterMetaType< ::QStyleOptionFocusRect::StyleOptionType >("QStyleOptionFocusRect::StyleOptionType");
    qRegisterMetaType< ::QStyleOptionFocusRect::StyleOptionVersion >("QStyleOptionFocusRect::StyleOptionVersion");
}
